<template>
  <div
    v-if="user!=null && user.canUploadDsnFile"
    class="container container-with-menu"
  >
    <div class="row">
      <h1><upload-icon :blue="true" />Fichiers DSN</h1>
    </div>
    <p>
      Veuillez ajouter un ou plusieurs fichiers DSN qui vous permettront de constituer votre base de données nécessaire à l’application.
    </p>
    <p>
      <u>Remarque</u> : Les fichiers DSN sont au format .txt .edi ou .dsn. Si vous avez des doutes sur la nature de vos fichiers DSN vous pouvez <a href="mailto: contact@dsnplus.fr">nous contacter par mail</a> ou par téléphone au 04 67 67 15 85.
    </p>
    <hr>
    <div class="row">
      <div
        class="col-xs-12 col-md-6 col-lg-6"
        style="text-align: center;"
      >
        <files-upload-form
          @showWaitingPopup="displayWaitingPopup()"
        />
      </div>
      <div
        v-if="isOn===false"
        class="col-xs-12 col-md-6 col-lg-6"
        style="text-align: center;"
      >
        <archive-upload-form
          @showWaitingPopup="displayWaitingPopup()"
        />
      </div>
    </div>
    <dsn-file-table />
    <waiting-dsn-file-modal
      v-if="showWaitingPopup && !dsnFilesWithOkStatus && !hasError"
    />
    <first-dsn-file-with-status-ok-modal
      v-if="showSuccessPopup===true"
      @okClicked="$router.push({path: '/tableau-de-bord'})"
    />
  </div>
  <div
    v-else
    class="container-with-menu"
  >
    Vous n'avez pas la permission requise pour transmettre des fichiers DSN.
  </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex'
import WaitingDsnFileModal from '../../../components/Modal/WaitingDsnFileModal'
import FirstDsnFileWithStatusOkModal from '../../../components/Modal/FirstDsnFileWithStatusOkModal'
import UploadIcon from '../../../components/Icon/UploadIcon'
import FilesUploadForm from '../../../components/Form/Upload/FilesUploadForm.vue'
import ArchiveUploadForm from '../../../components/Form/Upload/ArchiveUploadForm.vue'
import DsnFileTable from "./DsnFileTable";

export default {
  name: "DsnFile",
  components: {
    DsnFileTable,
    UploadIcon,
    FirstDsnFileWithStatusOkModal,
    WaitingDsnFileModal,
    FilesUploadForm,
    ArchiveUploadForm},
  data() {
    return {
      validator: null,
      interval : null,
      showWaitingPopup: false,
      showSuccessPopup: false,
      dsnFileAndIndex: null,
      deleteDataChoice: false,
    }
  },
  computed: {
    ...mapGetters([
      'dsnFiles',
      'dsnFilesToRefresh',
      'dsnFilesWithOkStatus',
      'user',
      'isOn',
      'wizard',
      'dsnFilesUpdated',
      'hasError'
    ]),
  },
  beforeDestroy: function () {
    clearInterval(this.interval)
  },
  created() {
    this.fetchDsnFiles()
  },
  mounted() {
    this.interval = setInterval(() => {
      this.refreshDsnFiles()
    }, 12000);
  },
  methods: {
    ...mapActions([
      'fetchDsnFiles',
      'refreshDsnFilesStatus',
      'loadingStarts',
      'loadingEnds',
      'firstDsnFileAddedAndStatusOk',
    ]),
    refreshDsnFiles() {
      this.refreshDsnFilesStatus(this.dsnFilesToRefresh)
        .then(()=>{
          if(this.dsnFilesUpdated===true) {
            if($('#waitingDsnFilePopup')!=null) {
              this.showWaitingPopup = false
              $('#waitingDsnFilePopup').modal('hide')
            }
            if(this.dsnFilesWithOkStatus && this.wizard.isFirstDsnFileAddedAndStatusOk===false) {
              this.firstDsnFileAddedAndStatusOk().then(()=>{
                this.showSuccessPopup = true
              })
            }
          }
        })
    },
    displayWaitingPopup() {
      this.showWaitingPopup = true
    }
  }
}
</script>